package goap

type MastoDevicesData struct {
	FullIdType
}

func (actor *MastoDevicesData) GetSelfOrBase() (BaseApChain, bool) {
	return actor.FullIdType.GetSelfOrBase()
}

func (actor *MastoDevicesData) MarshalToMap() map[string]any {
	return actor.FullIdType.MarshalToMapWithName(KEY_MASTO_DEVICES)
}

func ParseMastoDevicesData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	id, err := ParseIdTypeWithName(raw, next, KEY_MASTO_DEVICES)
	if err != nil {
		return nil, err
	}
	return &MastoDevicesData{FullIdType: *id}, nil
}

type MastoDiscoverableData struct {
	FullValueType[bool]
}

func (namedata *MastoDiscoverableData) GetSelfOrBase() (BaseApChain, bool) {
	return namedata.Next, true
}

func (namedata *MastoDiscoverableData) MarshalToMap() map[string]any {
	return namedata.MarshalToMapWithName(KEY_MASTO_DISCOVERABLE)
}

func ParseMastoDiscoverableData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	tmp, err := ParseValueTypeWithName[bool](raw, next, KEY_MASTO_DISCOVERABLE)
	if err != nil {
		return nil, err
	}
	return &MastoDiscoverableData{*tmp}, nil
}

type MastoFeaturedData struct {
	FullIdType
}

func (actor *MastoFeaturedData) GetSelfOrBase() (BaseApChain, bool) {
	return actor.FullIdType.GetSelfOrBase()
}

func (actor *MastoFeaturedData) MarshalToMap() map[string]any {
	return actor.FullIdType.MarshalToMapWithName(KEY_MASTO_FEATURED)
}

func ParseMastoFeaturedData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	id, err := ParseIdTypeWithName(raw, next, KEY_MASTO_FEATURED)
	if err != nil {
		return nil, err
	}
	return &MastoFeaturedData{FullIdType: *id}, nil
}

type MastoFeaturedTagsData struct {
	FullIdType
}

func (actor *MastoFeaturedTagsData) GetSelfOrBase() (BaseApChain, bool) {
	return actor.FullIdType.GetSelfOrBase()
}

func (actor *MastoFeaturedTagsData) MarshalToMap() map[string]any {
	return actor.FullIdType.MarshalToMapWithName(KEY_MASTO_FEATURED_TAGS)
}

func ParseMastoFeaturedTagsData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	id, err := ParseIdTypeWithName(raw, next, KEY_MASTO_FEATURED_TAGS)
	if err != nil {
		return nil, err
	}
	return &MastoFeaturedTagsData{FullIdType: *id}, nil
}

type MastoIndexableData struct {
	FullValueType[bool]
}

func (namedata *MastoIndexableData) GetSelfOrBase() (BaseApChain, bool) {
	return namedata.Next, true
}

func (namedata *MastoIndexableData) MarshalToMap() map[string]any {
	return namedata.MarshalToMapWithName(KEY_MASTO_INDEXABLE)
}

func ParseMastoIndexableData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	tmp, err := ParseValueTypeWithName[bool](raw, next, KEY_MASTO_INDEXABLE)
	if err != nil {
		return nil, err
	}
	return &MastoIndexableData{*tmp}, nil
}

type MastoMemorialData struct {
	FullValueType[bool]
}

func (namedata *MastoMemorialData) GetSelfOrBase() (BaseApChain, bool) {
	return namedata.Next, true
}

func (namedata *MastoMemorialData) MarshalToMap() map[string]any {
	return namedata.MarshalToMapWithName(KEY_MASTO_MEMORIAL)
}

func ParseMastoMemorialData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	tmp, err := ParseValueTypeWithName[bool](raw, next, KEY_MASTO_MEMORIAL)
	if err != nil {
		return nil, err
	}
	return &MastoMemorialData{*tmp}, nil
}
