package goap

// NOTE: Different to ASSummaryData
// Misskey summary is the raw text without formatting applied while the Activitystreams summary already contains the preformatted summary
type MKSummaryData struct {
	FullValueType[string]
}

func (misskeysummarydata *MKSummaryData) GetSelfOrBase() (BaseApChain, bool) {
	return misskeysummarydata.Next, true
}

func (misskeysummarydata *MKSummaryData) MarshalToMap() map[string]any {
	return misskeysummarydata.MarshalToMapWithName(KEY_MISSKEY_MKSUMMARY)
}

func ParseMKSummaryData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	tmp, err := ParseValueTypeWithName[string](raw, next, KEY_MISSKEY_MKSUMMARY)
	if err != nil {
		return nil, err
	}
	return &MKSummaryData{*tmp}, nil
}

type MKIsCatData struct {
	FullValueType[bool]
}

func (iscatdata *MKIsCatData) GetSelfOrBase() (BaseApChain, bool) {
	return iscatdata.Next, true
}

func (iscatdata *MKIsCatData) MarshalToMap() map[string]any {
	return iscatdata.MarshalToMapWithName(KEY_MISSKEY_ISCAT)
}

func ParseMKIsCatData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	tmp, err := ParseValueTypeWithName[bool](raw, next, KEY_MISSKEY_ISCAT)
	if err != nil {
		return nil, err
	}
	return &MKIsCatData{*tmp}, nil
}

type FFSpeakAsCatData struct {
	FullValueType[bool]
}

func (iscatdata *FFSpeakAsCatData) GetSelfOrBase() (BaseApChain, bool) {
	return iscatdata.Next, true
}

func (iscatdata *FFSpeakAsCatData) MarshalToMap() map[string]any {
	return iscatdata.MarshalToMapWithName(KEY_FIREFISH_SPEAKASCAT)
}

func ParseFFSpeakAsCatData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	tmp, err := ParseValueTypeWithName[bool](raw, next, KEY_FIREFISH_SPEAKASCAT)
	if err != nil {
		return nil, err
	}
	return &FFSpeakAsCatData{*tmp}, nil
}

type MKQuoteData struct {
	FullValueType[string]
}

func (misskeysummarydata *MKQuoteData) GetSelfOrBase() (BaseApChain, bool) {
	return misskeysummarydata.Next, true
}

func (misskeysummarydata *MKQuoteData) MarshalToMap() map[string]any {
	return misskeysummarydata.MarshalToMapWithName(KEY_MISSKEY_MKQUOTE)
}

func ParseMKQuoteData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	tmp, err := ParseValueTypeWithName[string](raw, next, KEY_MISSKEY_MKQUOTE)
	if err != nil {
		return nil, err
	}
	return &MKQuoteData{*tmp}, nil
}
