package goap

type OstatusAtomUriData struct {
	FullValueType[string]
}

func (atomurivalue *OstatusAtomUriData) GetSelfOrBase() (BaseApChain, bool) {
	return atomurivalue.Next, true
}

func (atomurivalue *OstatusAtomUriData) MarshalToMap() map[string]any {
	return atomurivalue.MarshalToMapWithName(KEY_OSTATUS_ATOMURI)
}

func ParseOstatusAtomUriData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	v, err := ParseValueTypeWithName[string](raw, next, KEY_OSTATUS_ATOMURI)
	if err != nil {
		return nil, err
	}
	return &OstatusAtomUriData{*v}, nil
}

type OstatusConversationData struct {
	FullValueType[string]
}

func (atomurivalue *OstatusConversationData) GetSelfOrBase() (BaseApChain, bool) {
	return atomurivalue.Next, true
}

func (atomurivalue *OstatusConversationData) MarshalToMap() map[string]any {
	return atomurivalue.MarshalToMapWithName(KEY_OSTATUS_CONVERSATION)
}

func ParseOstatusConversationData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	v, err := ParseValueTypeWithName[string](raw, next, KEY_OSTATUS_CONVERSATION)
	if err != nil {
		return nil, err
	}
	return &OstatusConversationData{*v}, nil
}

type OstatusReplyToAtomUriData struct {
	FullValueType[string]
}

func (a *OstatusReplyToAtomUriData) GetSelfOrBase() (BaseApChain, bool) {
	return a.Next, true
}

func (a *OstatusReplyToAtomUriData) MarshalToMap() map[string]any {
	return a.MarshalToMapWithName(KEY_OSTATUS_INREPLYTOATOMURI)
}

func ParseOstatusInReplyToAtomUriData(raw map[string]any, next BaseApChain) (BaseApChain, error) {
	v, err := ParseValueTypeWithName[string](raw, next, KEY_OSTATUS_INREPLYTOATOMURI)
	if err != nil {
		return nil, err
	}
	return &OstatusReplyToAtomUriData{*v}, nil
}
